import javax.xml.parsers.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
public class JNLPReader {
	public JNLPReader() {
		Document doc = parseXML("asteroids.jnlp");
		printNodes(doc,0);
	}
	protected void printNodes(Node node,int depth) {
		int x;
		for (x = 0;x < depth;x++) System.out.print("--"+(x == depth-1?">":""));
		System.out.println(node.getNodeName());
		if (node.hasAttributes()) {
			NamedNodeMap map = node.getAttributes();
			for (x = 0;x < map.getLength();x++) {
				printNodes(map.item(x),depth+2);
			}
		}
		if (node.hasChildNodes()) {
			NodeList list = node.getChildNodes();
			for (x = 0;x < list.getLength();x++) printNodes(list.item(x),depth+1);
		}
	}
	protected Document parseXML(String s) {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                factory.setValidating(false);
		try {
			Document doc = factory.newDocumentBuilder().parse(new FileInputStream(s));
			return doc;
		}
		catch (SAXException e) {
			e.printStackTrace();
		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
            return null;
	}
	public static void main(String args[]) {
		new JNLPReader();
	}
}