/* Archives the Java 4K 2007 game entries
* The archived files will be stored on Java Unlimited's harddrive
*
* The data received from the PHP script tells the archiver where to
* download the games. Each line represents one game, and is the following format:
*
* <game title> | <screenshot file> | <JAR/ZIP file> | <JNLP file> <id>
*
* the archiver will try its best to parse the JNLP file and figure
* out which file needs to be downloaded in order for the webstart
* version to work. */
import javax.xml.parsers.*;
import java.io.*;
import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.xml.sax.*;
public class Archive {
	public static final String DATA_URL = "http://javaunlimited.net/games/archive/4K07/archive.php";
	public static final int TITLE = 0,SCREEN = 1,FILE = 2,JNLP = 3,ID = 4;
	public static PrintStream log = null;
	public static PrintStream sql = null;
	public Archive() throws IOException {
		println("Loading data ... ");
		URL u = new URL(DATA_URL);
		BufferedReader b = new BufferedReader(new InputStreamReader(u.openStream()));
		String s = "";
		while ((s = b.readLine()) != null) {
			process(s);
		}
		b.close();
		sql.println("db_close();");
		sql.println("?>");
	}
	protected void process(String s) throws IOException {
		s = fix(s);
		//println(s);
		StringTokenizer st = new StringTokenizer(s,"|");
		String data[] = new String[5];
		int x = 0;
		while (st.hasMoreTokens() && x < data.length) data[x++] = st.nextToken();
		println("---"+data[TITLE]+"---");
		data[TITLE] = data[TITLE].replaceAll(" ","");
		data[TITLE] = data[TITLE].replaceAll(":","");
		// download file
		if (!data[FILE].trim().equals("") && !data[FILE].equals(" ") && !data[FILE].equalsIgnoreCase("http://")) {
			String file = ""+data[FILE];
			String dst = ""+data[TITLE]+"/"+file.substring(file.lastIndexOf("/")+1,file.length());
			sql.println("sql(\"UPDATE `games` SET `file` = '\".encodestr(\"http://javaunlimited.net/games/archive/4K07/"+dst+"\").\"' WHERE `id` = "+data[ID]+"\");");
			download(file,dst);
			println("");
		}
		// download jnlp
		if (!data[JNLP].trim().equals("") && !data[JNLP].equals(" ") && !data[JNLP].equalsIgnoreCase("http://")) {
			String file = ""+data[JNLP];
			String dst = ""+data[TITLE]+"/"+file.substring(file.lastIndexOf("/")+1,file.length());
			if (download(file,dst)) {
				Document d;
				if ((d = parseJNLP(dst)) != null) {
					sql.println("sql(\"UPDATE `games` SET `jnlp` = '\".encodestr(\"http://javaunlimited.net/games/archive/4K07/"+data[TITLE]+"/webstart.jnlp\").\"' WHERE `id` = "+data[ID]+"\");");
					println(" (valid JNLP!)");
					editJNLP(d,dst,data[TITLE]+"/");
				}
				else println(" (invalid JNLP!)");
				//println("");
			}
			else println("");
		}
		// download screenshot
		if (!data[SCREEN].trim().equals("") && !data[SCREEN].equals("none") && !data[SCREEN].equals("") && !data[SCREEN].equals("http://")) {
			String file = ""+data[SCREEN];
			String dst = "";
			if (file.indexOf("?") > 0) dst = ""+data[TITLE]+"/screen"+file.substring(file.lastIndexOf("."),file.lastIndexOf("?"));
			else dst = ""+data[TITLE]+"/screen"+file.substring(file.lastIndexOf("."),file.length());
			sql.println("sql(\"UPDATE `games` SET `icon` = '\".encodestr(\"http://javaunlimited.net/games/archive/4K07/"+dst+"\").\"' WHERE `id` = "+data[ID]+"\");");
			download(file,dst);
			println("");
		}
		println("");
	}
	protected Node getNode(Node parent,String name) {
		// returns the first node by name
		NodeList list = parent.getChildNodes();
		Node node = null;
		for (int j = 0;j < list.getLength();j++) {
			if (list.item(j).getNodeName().equalsIgnoreCase(name)) {
				return list.item(j);
			}
		}
		return null;
	}
	public String getAttribute(Node parent,String name) {
		NamedNodeMap map = parent.getAttributes();
		Node node = null;;
		for (int j = 0;j < map.getLength();j++) {
			node = map.item(j);
			if (node.getNodeName().equalsIgnoreCase(name)) {
				return node.getNodeValue();
			}
		}
		return null;
	}
	protected void editJNLP(Document doc,String src,String dst) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(src)));
		PrintStream out = new PrintStream(new FileOutputStream(dst+"webstart.jnlp"));
		// look for the <jar> tag so we know which webstart jar to download
		Node jnlp = getNode(doc,"JNLP");
		String codebase = getAttribute(jnlp,"CODEBASE");
		if (codebase != null && !codebase.endsWith("/")) {
			codebase+="/";
		}
		Node res = getNode(jnlp,"RESOURCES");
		Node jar = getNode(res,"JAR");
		String file = getAttribute(jar,"href");
		//println(codebase+" / "+file);
		if (file != null) {
			File f;
			if (file.indexOf("/") >= 0 || file.startsWith("http://")) {
				f = new File(dst+file.substring(file.lastIndexOf("/")+1,file.length()));
				if (!f.exists()) {
					download(file,dst+file.substring(file.lastIndexOf("/")+1,file.length()));
					println("");
				}
			}
			else {
				f = new File(dst+file);
				if (!f.exists()) {
					download(codebase+""+file,dst+file);
					println("");
				}
			}
		}
		boolean tagOpen = false;
		String s = "";
		while ((s = in.readLine()) != null) {
			String tmp = s.trim().toLowerCase();
			if (tmp.startsWith("<jnlp") || tmp.startsWith("< jnlp")) {
				out.println("<jnlp spec=\"1.0\" codebase=\"http://javaunlimited.net/games/archive/4K07/"+dst+"\" href=\"webstart.jnlp\">");
				tagOpen = (s.indexOf(">") < 0);
			}
			else if (tmp.startsWith("<jar") || tmp.startsWith("< jar")) {
				out.println("<jar href=\""+file+"\"/>");
				tagOpen = (s.indexOf(">") < 0);
			}
			else if (tagOpen) {
				tagOpen = (s.indexOf(">") < 0);
			}
			else out.println(s);
		}
		in.close();
		out.close();
	}
	protected Document parseJNLP(String s) {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                factory.setValidating(false);
		try {
			BufferedReader b = new BufferedReader(new InputStreamReader(new FileInputStream(s)));
			String buf[] = new String[1024];
			int x = 0;
			String tmp = "";
			while ((tmp = b.readLine()) != null) {
				tmp = tmp.trim();
				if (!tmp.startsWith("<?")) buf[x++] = ""+tmp;
				else {
					if (tmp.startsWith("<?xml")) buf[x++] = ""+tmp;
				}
			}
			b.close();
			PrintStream p = new PrintStream(new FileOutputStream(s));
			for (int j = 0;j < x;j++) p.println(buf[j]);
			p.close();
			Document doc = factory.newDocumentBuilder().parse(new FileInputStream(s));
			return doc;
		}
		catch (SAXException e) {
			print(" (Error: "+e.getMessage()+")");
		}
		catch (ParserConfigurationException e) {
			print(" (Error: "+e.getMessage()+")");
		}
		catch (IOException e) {
			print(" (Error: "+e.getMessage()+")");
		}
            return null;
	}
	protected String fix(String s) {
		String fix = "";
		for (int x = 0;x < s.length();x++) {
			if (x < s.length()-1 && s.charAt(x) == '|' && s.charAt(x+1) == '|') {
				fix+="| |";
				x++;
			}
			else fix+=s.charAt(x);
		}
		return fix;
	}
	protected static final boolean download(String src,String dst) {
		print("Downloading "+dst+"...");
		try {
			File f = new File(dst.substring(0,dst.lastIndexOf("/")));
			f.mkdir();
			f = new File(dst);
			if (f.exists()) return true;
			URL u = new URL(src);
			InputStream in = u.openStream();
			PrintStream out = new PrintStream(new FileOutputStream(dst));
			int x = 0;
			int b = 0;
			while ((x = in.read()) >= 0) {
				out.write(x);
				b++;
			}
			print(" ("+b+" bytes)");
			in.close();
			out.close();
		}
		catch (IOException e) {
			print(" (ERROR!)");
			return false;
		}
		//println("");
		return true;
	}
	protected static final void print(String s) {
		System.out.print(s);
		log.print(s);
	}
	protected static final void println(String s) {
		System.out.println(s);
		log.println(s);
	}
	public static void main(String args[]) {
		try {
			log = new PrintStream(new FileOutputStream("log.txt"));
			sql = new PrintStream(new FileOutputStream("script.php"));
			BufferedReader b = new BufferedReader(new InputStreamReader(new FileInputStream("template.php")));
			String s = "";
			while ((s = b.readLine()) != null) {
				sql.println(s);
			}
			b.close();
			new Archive();
			log.close();
			sql.close();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
}